// SScreenMode.cpp: Implementierung der Klasse SScreenMode.
//
// Copyright by Andr Stein
// E-Mail: stonemaster@steinsoft.net, andre_stein@web.de
// http://www.steinsoft.net
//////////////////////////////////////////////////////////////////////
#include "stdafx.h"
#include "SScreenMode.h"

//////////////////////////////////////////////////////////////////////
// Konstruktion/Destruktion
//////////////////////////////////////////////////////////////////////

SScreenMode::SScreenMode()
{
	screenModeSet = false;
}

SScreenMode::~SScreenMode()
{
	reset();
}

SScreenMode::SScreenMode(int width, int height, int bpp)
{
	if (!setDisplayMode(width, height, bpp))
	{
		return;
	}
}

//////////////////////////////////////////////////////////////////////
// Funktionen
//////////////////////////////////////////////////////////////////////

bool SScreenMode::setDisplayMode(int width, int height, int bpp)
{
	DEVMODE displayMode;
	
	//Speichert die jetzige Bildschirmauflsung
	EnumDisplaySettings(NULL, ENUM_REGISTRY_SETTINGS, &savedMode);
	
	memset(&displayMode, 0 , sizeof(displayMode));

	displayMode.dmSize          = sizeof(displayMode);		
	displayMode.dmPelsWidth	    = width;			
	displayMode.dmPelsHeight	= height;	
	displayMode.dmBitsPerPel	= (bpp == -1 ? savedMode.dmBitsPerPel : bpp);		
	displayMode.dmFields        =  DM_BITSPERPEL | 
								   DM_PELSWIDTH  |
								   DM_PELSHEIGHT;



	if (ChangeDisplaySettings(&displayMode , CDS_FULLSCREEN)
		!= DISP_CHANGE_SUCCESSFUL)
	{
		OutputDebugString("SScreenmode : Displaymode changing failed!\n");
		return false;
	}
	
	screenModeSet = true;

	OutputDebugString("SScreenmode : Displaymode changed successfully!\n");

	return true;
}

void SScreenMode::reset()
{
	if (!screenModeSet)
	{
		return;
	}

	if (!ChangeDisplaySettings(NULL,CDS_TEST)) 
	{ 		
		ChangeDisplaySettings(NULL,CDS_RESET);		 
		ChangeDisplaySettings(&savedMode,CDS_RESET);	
	}
	else 
	{
		ChangeDisplaySettings(NULL,CDS_RESET);		
	}

	screenModeSet = false;
}


